'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LocalStorage = undefined;

var _autoStorage = require('./auto-storage');

Object.defineProperty(exports, 'LocalStorage', {
  enumerable: true,
  get: function () {
    return _interopRequireDefault(_autoStorage).default;
  }
});

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class ExplicitSaving extends _events2.default {
  constructor() {
    super();
    this.currentOrder = [];
    this.persistedOrder = [];
  }

  parseGridChildren(gridNode) {
    const children = [];
    for (const i of gridNode.children) {
      children.push({ id: i.id, guid: i.attributes['data-gridifier-guid'].value });
    }
    return children.sort((a, b) => {
      return a.guid - b.guid;
    });
  }

  onChange(gridNode) {
    const order = this.parseGridChildren(gridNode);
    this.currentOrder = order;
  }

  persistOrder() {
    this.persistedOrder = this.currentOrder;
  }

  restoreOrder() {
    this.emit('sort-order-list', this.persistedOrder);
  }
}

exports.default = ExplicitSaving;